//   GreKo chess engine
//   (c) 2002-2020 Vladimir Medvedev <vrm@bk.ru>
//   http://greko.su

#ifndef EVAL_H
#define EVAL_H

#include "eval_params.h"
#include "position.h"

struct PawnHashEntry;

void GetFeatures(const Position& pos, vector<double>& features);
void GetFeaturesSide(const Position& pos, COLOR side, const PawnHashEntry& pentry, int sign, vector<double>& features);

void AddFeatureLinear(size_t tagEnum, int value, int maxValue, int sign, vector<double>& features);
void AddFeatureSquare(size_t tagEnum, int value, int maxValue, int sign, vector<double>& features);
void AddFeatureScaled(size_t tagEnum, int value, int maxValue, int sign, vector<double>& features);

void AddFeatureVector(size_t tagEnum, size_t arrayIndex, int sign, vector<double>& features);
void AddFeaturesPsq(size_t tagEnum, FLD f, COLOR side, int sign, vector<double>& features);

EVAL Evaluate(const Position& pos, EVAL alpha = -INFINITY_SCORE, EVAL beta = INFINITY_SCORE);
void InitEval();
void InitEval(const vector<int>& x);
void SetPawnHashSize(double mb);

#endif
